#################################################################################################################
#
# Copyright (C) 2013-2015 X2Go Project - http://wiki.x2go.org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Copyright (C) 2013-2015 Guangzhou Nianguan Electronics Technology Co.Ltd. <opensource@gznianguan.com>
# Copyright (C) 2013-2015 Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
#
#################################################################################################################
package X2Go::Telekinesis::CommonCore;
use strict;
use Exporter qw(import);
our @EXPORT_OK = qw(tcDie sanitizer  checkPID sanitizeFilePath sanitizeDirPath genRandSID genRandFID clups dbugPrint);


sub tcDie {
  print "\n###########################################################\n$ENV{'APPNAME'} v$ENV{'APPVER'}\n###########################################################\n\n@_\n\n...\n\n";
  exit;die;die;die;# EXIT or DIE DIE DIE!!!!!!!!!!!
}

sub dbugPrint {
  if ($ENV{'TKDBUGDUMP'} eq 1) {print "@_\n";}
}

sub sanitizeDirPath {
# NOT REALLY WORTH A DAMN, SOMEONE SHOULD FIX THIS!!!
  my $fPath = $_[0];
  $fPath =~ s/\;//g;
  if (-d $fPath) {
    if ($fPath  =~ /^(.*)$/) {
      $fPath = $1;
      return $fPath;
    } else {return 0;}
  } else {return 0;}
}

sub sanitizeFilePath {
# NOT REALLY WORTH A DAMN, SOMEONE SHOULD FIX THIS!!!
  my $fPath = $_[0];
  $fPath =~ s/\;//g;
  if (-f $fPath) {
    if ($fPath  =~ /^(.*)$/) {
      $fPath = $1;
      return $fPath;
    } else {return 0;}
  } else {return 0;}
}

sub sanitizer {
# Overzealous string sanitizer that makes perl strict and  perl -T happy...
  my $type   = $_[0];
  my $string = $_[1];
  if ($type eq "anumazcs") {
    $string =~ s/[^a-zA-Z0-9]//g;
    if ($string =~ /^([a-zA-Z0-9]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "alpazuc") {
    $string = uc($string);
    $string =~ s/[^A-Z]//g;
    if ($string =~ /^([A-Z]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "alpazlc") {
    $string = lc($string);
    $string =~ s/[^a-z]//g;
    if ($string =~ /^([a-z]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "anumazlc") {
    $string = lc($string);
    $string =~ s/[^a-z0-9]//g;
    if ($string =~ /^([a-z0-9]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq  "num") {
    $string =~ s/\D//g;
    if ($string =~ /^([0-9]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq  "numdot") {
    $string =~ s/[^0-9\.]//g;
    if ($string =~ /^([0-9\.]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "anumazcsdaus") {
    $string =~ s/[^a-zA-Z0-9\_\-]//g;
    if ($string =~ /^([a-zA-Z0-9\_\-]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "anumazcsdausdots") {
    $string =~ s/[^a-zA-Z0-9\_\-\:\.]//g;
    if ($string =~ /^([a-zA-Z0-9\_\-\:\.]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "anumazcsdausdotspipe") {
    $string =~ s/[^a-zA-Z0-9\_\-\:\.\|]//g;
    if ($string =~ /^([a-zA-Z0-9\_\-\:\.\|]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "pnixusername") {
    $string =~ s/[^a-zA-Z0-9\_\-\.]//g;
    if ($string =~ /^([a-zA-Z0-9\_\-\.]*)$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "tekiappname") {
    $string = lc($string);
    $string =~ s/[^a-z]//g;
    if ($string =~ /^([a-z]{4,32})$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "tekiappsid") {
    $string =~ s/[^a-zA-Z0-9]//g;
    if ($string =~ /^([a-zA-Z0-9]{3,32})$/) {
      $string = $1;
      return $string;
    } else {return 0;}
  } elsif ($type eq "x2gosid") {
          $string =~ s/[^a-zA-Z0-9\_\-\$\.]//g;
          if ($string =~ /^([a-zA-Z0-9\_\-\$\.]*)$/) {
                  $string = $1;
                  if ($string =~ /^([a-zA-Z\_][a-zA-Z0-9\_\-\.]{0,31}[\$]?)\-([\d]{2,4})\-([\d]{9,12})\_[a-zA-Z0-9\_\-]*\_dp[\d]{1,2}$/) {
                          if ((length($1) > 0) and (length($1) < 32)){
                                  return $string;
                          } else {return 0;}
                  } else {return 0;}
          } else {return 0;}
  } elsif ($type eq "SOMETHINGELSE") {
    return 0;
  } else {tcDie("Some dumb smuch asked for a non-existent sanitation rule....\nIt may be a big deal... or it may not be...\nNevertheless, we're putting an end to this...");}
}

sub checkPID {
  my $inpid = sanitizer("num",$_[0]);
  open(PS,"/bin/ps --no-headers -o %u,%p,%n,%c -p $inpid|");
  my ($pidInf,undef) = <PS>;
  close(PS);
  my ($user,$pid,$nice,$cmd)  = split(/\,/,clups($pidInf));
  $pid =~ s/\D//g;
  return ($pid,$user,$nice,$cmd)
}

sub genRandSID {
  srand();
  my $time = time();
  my $rcnt = (24 - length($time));
  my @chars = ('0'..'9','a'..'z','A'..'Z');
  my $randmake;
  for (my $i=0; $i<$rcnt; $i++) {$randmake .= $chars[int(rand($#chars + 1))];}
  return clups("$time$randmake");
}

sub genRandFID {
  srand();
  my $time = time();
  my $rcnt = (32 - length($time));
  my @chars = ('0'..'9','a'..'z','A'..'Z');
  my $randmake;
  for (my $i=0; $i<$rcnt; $i++) {$randmake .= $chars[int(rand($#chars + 1))];}
  return clups("$time$randmake");
}

sub clups {my $string = "@_";$string =~ s/\n//g;$string =~ s/\ //g;$string =~ s/\s//g;return $string;}


1;
